#include "gdgraph.h"
#include <string.h>

/* 1$BF|C10L$N%0%i%U$rIA2h(B */


NtState ggGraphDaily(GdCont *cont) 
{
  FILE *ifp;
  char buf[LINEMAX];
  int  x,y,x0,y0,bCont;
  
  cont->xdiv[0] = 4;
  cont->xdiv[1] = 24;
  cont->ydiv[0] = 5;
  cont->ydiv[1] = 20;

  ggDailyGrid(cont);  /* $B%0%j%C%IIA2h(B */

  /* $B%0%i%UIA2h(B */

  if(ggDailyOpenFile(cont, &ifp)!=NtOk)   /* $B%U%!%$%k$r3+$$$F(B */
    return NtError;

  bCont = x0 = y0 = 0;
  while(fgets(buf, LINEMAX, ifp)!=NULL) {  /* EOF$B$^$G(B          */
    if(ggDailyDataGet(cont, buf, &x, &y)){ /*  $B>r7o$K$"$&%G!<%?$N$_<hF@(B */
      if(bCont)
	gdImageLine(cont->im, x, y, x0, y0, cont->clLine); /* $BIA2h(B */
      gdImageSetPixel(cont->im, x0, y0, cont->clPoint);
      x0 = x;
      y0 = y;
      bCont = 1;
    }
    else bCont = 0;
  }
  fclose(ifp);
  
  return NtOk;
}

void ggDailyGrid(GdCont *cont)
{
  int x,y,i,j;
  int w = cont->x[2] - cont->x[1];
  int h = cont->y[2] - cont->y[1];
  int color;
  char str[16];
  gdFont *font = gdFontTiny;
  
  for(j=1;j>=0;j--){
    color = cont->clGrid[j];
    for(i=0;i<= cont->xdiv[j];i++){
      x = i * w / cont->xdiv[j] + cont->x[1];
      gdImageLine(cont->im, x, cont->y[1], x, cont->y[2], color);
    }
    for(i=0; i<= cont->ydiv[j];i++){
      y = i * h / cont->ydiv[j] + cont->y[1];
      gdImageLine(cont->im, cont->x[1], y, cont->x[2], y, color);
    }
  }

  /* x$B<4$NJ8;z(B */

  y = cont->y[1] + font->h;
  for(i=0;i<= cont->xdiv[0];i++){
    int hh;
    hh = 24 * i / cont->xdiv[0];
    sprintf(str,"%d",hh);
    x = i * w / cont->xdiv[0] + cont->x[1] - font->w * strlen(str)/2;
    gdImageString(cont->im, font, x, y, str, cont->clTic);
  }
  sprintf(str,"[Hour]");
  y = cont->y[1] + font->h * 2;
  x = cont->x[2] - font->w * strlen(str);
  gdImageString(cont->im, font, x, y, str, cont->clTic);
  

  /* y$B<4$NJ8;z(B */
  
  for(i=0; i<= cont->ydiv[0];i++){
    int byps;
    y = i * h / cont->ydiv[0] + cont->y[1] - font->h /2;
    byps = 100 * i / cont->ydiv[0];
    sprintf(str,"%d",byps);
    x  = cont->x[1] - 3 - strlen(str) * font->w;
    gdImageString(cont->im, font , x, y, str, cont->clTic);
  }
  sprintf(str,"[Kbyte/sec]");
  x  = cont->x[1] - (strlen(str) - 5) * font->w;
  y  = cont->y[2] - font->h*2;
  gdImageString(cont->im, font , x, y, str, cont->clTic);
}


NtState ggDailyOpenFile(GdCont *cont,FILE **pFp)
{
#ifdef __i386__
   char *fileName = "/home/nari/wrk/gdgraph/ftpperf.log";
#else
   char *fileName = "/var/log/ftpperf/ftpperf.log";
#endif

   *pFp = fopen(fileName,"r");
   if(*pFp == NULL)
     return ntErrMes("\"%s\" not found.",fileName);
   return NtOk;
}

int ggDailyDataGet(GdCont *cont,char *line,int *pX,int *pY)
{
  int hh,mm,ss,byps;
  if(cont->sDatePat == NULL){
    struct tm *tm = localtime(&cont->date);
    cont->sDatePat = ntMalloc(12);
    cont->cDatePat = strftime(cont->sDatePat,12,"%Y/%m/%d",tm);
  }
  if(strncmp(line,cont->sDatePat,cont->cDatePat)!=0)
    return 0;
  if(sscanf(line,"%*s %d:%d:%d %*d %*f %d",&hh,&mm,&ss,&byps)<4)
    return 0;

  *pX = (hh*3600+mm*60+ss)*(cont->x[2]- cont->x[1])/(3600*24)+cont->x[1];
  *pY = byps * (cont->y[2] - cont->y[1])/100000 + cont->y[1];
  return 1;
}
