#include "gdgraph.h"

int main(int argc, char *argv[])
{
  FILE *ofp = stdout;
  GdCont *cont = ggContNew();
  
  if(ntCgiPara(&cont->param)!=NtOk){      /* $B%Q%i%a!<%?$rFI$_$@$7(B; */
    ntErrHtml(ofp,"parameter parse error");
    exit(1);
  }

  ggSetCont(cont);  /* gd$B$r=i4|2=(B; */
  
  if(ggGraphDaily(cont)!=NtOk){  /* $B%0%i%U$rIA2h(B; */
    ntErrHtml(ofp,"graphDaily error");
    exit(1);
  }
    
  /* $B%U%!%$%k$r=PNO(B; */
  fprintf(ofp,"Content-type: image/png\n\n");
  gdImagePng(cont->im, ofp);
  
  return 0;
}

GdCont *ggContNew(void)
{
  GdCont *new = ntMalloc(sizeof(GdCont));
  new->param  = NULL;
  new->im     = NULL;
  new->width  = 300;
  new->height = 200;
  new->lm     = 30;
  new->rm     = 30;
  new->tm     = 30;
  new->bm     = 30;
  return new;
}

void ggSetCont(GdCont *cont)
{
  gdImagePtr im;
  
  cont->im = im = gdImageCreate(cont->width, cont->height);
  cont->clBg   = gdImageColorAllocate(im, 255, 255, 255);
  cont->clLine = gdImageColorAllocate(im,   0, 150,   0);
  cont->clAxis = gdImageColorAllocate(im,   0,   0,   0);
  cont->clGrid[0] = gdImageColorAllocate(im, 200, 200, 250);
  cont->clGrid[1] = gdImageColorAllocate(im, 240, 240, 250);
  cont->clPoint   = gdImageColorAllocate(im,   0,   0,   0);
  cont->clTic     = gdImageColorAllocate(im, 255,   0,   0);
  cont->x[0] = 0;
  cont->x[1] = cont->x[0] + cont->lm;
  cont->x[3] = cont->width-1;
  cont->x[2] = cont->x[3] - cont->rm;
  
  cont->y[3] = 0;
  cont->y[2] = cont->y[3] + cont->bm;
  cont->y[0] = cont->height - 1;
  cont->y[1] = cont->y[0] - cont->tm;

  cont->date = time(NULL);
  cont->sDatePat = NULL;
}
