#include <stdio.h>
#include <stdarg.h>
#include "ntLib.h"

static NtList *ntErrStack;

NtState ntErrMes(char *fmt, ...)
{
  va_list ap;
  char buf[LINEMAX*2];
  
  va_start(ap, fmt);
  vsnprintf(buf,sizeof(buf),fmt,ap);
  ntListPush(&ntErrStack,ntStringNew(buf));
  va_end(ap);
  return NtError;
}

void ntErrPrint(ofp, mes)
    FILE *ofp;
    char *mes;
{
  int i=0;
  char *str;

  fprintf(ofp,"%s\n",mes);
  while(ntListPop(&ntErrStack, &str)){
    fprintf(ofp,"[%d]%s\n",++i,str);
    ntStringFree(&str);
  }
}

/* Htmlǥ顼Ϥ롣 */
void ntErrHtml(ofp, mes) 
    FILE *ofp;
    char *mes;
{
  int i=0;
  char *str;

  fprintf(ofp,"Content-type: text/plain\n");
  fprintf(ofp,"status: 500 program error\n");
  fprintf(ofp,"\n");
  fprintf(ofp,"%s\n",mes);
  while(ntListPop(&ntErrStack, &str)){
    fprintf(ofp,"[%d]%s\n",++i,str);
    ntStringFree(&str);
  }
}

int ntErrAt(char *fileName,FILE *fp,char *fmt, ...)
{
  va_list ap;
  long posErr,posEol,posEol0,pos,posBol;
  int c,lineno,col,len;
  char mes[LINEMAX];
  char *line;

  /* å */
  
  va_start(ap, fmt);
  vsnprintf(mes,sizeof(mes), fmt, ap);
  va_end(ap);

  /* Կȡ Ƭֵ */
  
  posErr = ftell(fp);
  rewind(fp);
  lineno = 1;
  c = 0;
  for(posEol0 = posEol = pos = 0; pos < posErr; pos++){
    c = getc(fp);
    if(c == EOF)
      return ntErrMes("Unexpected EOF in ntErrAt(%s)",mes);
    if(c == '\n'){
      lineno++;
      posEol0 = posEol;
      posEol  = pos;
    }
  }

  if(posErr == 0){
    col = 0;
    posBol = 0;
  }
  else if(posErr == posEol){      /* ʸǥ顼 */
    posBol = posEol0;
    col = posErr - posBol;
  }
  else {
    posBol = posEol;
    col = posErr - posBol;
  }

  while(c != '\n' && c != EOF){
    pos++; 
    c = fgetc(fp);
  }
  posEol = pos;
  
  /* ɤ߹ */

  len = posEol - posBol - 1;
  line = ntMalloc(len+1);
  if(fseek(fp, posBol, 0) != 0)
    return ntErrMes("fseek error in ntErrAt(%s)",mes);
  fread(line, len, 1, fp);
  line[len] = 0;

  ntErrMes("%s\n   %s:%d\n   %s", mes, fileName, lineno, line);
  ntStringFree(&line);
  
  if(fseek(fp, posErr, 0) != 0)
    return ntErrMes("fseek error in ntErrAt(%s)",mes);
  return NtError;
}

